package mathematics;

public class Mathematics {

/** Constantes criadas para os mtodos que necessitam de dividir ou multiplicar por 10
 *  ou 2.
 */	
public static final int DEC=10; 
public static final int BIN=2; 

/** Mtodo que recebe um nmero (number) na base binria para converter para a base 
 *  decimal.
 *  power  um contador que representa a potncia de 2, ou seja, o n de vezes
 *  que 2 tem de multiplicar por 2. 
 *  ENQUANTO o quociente OU o resto da diviso inteira forem diferentes de 0,  
 *  calculado o resto da diviso inteira. Esse resto  somado ao resultado 
 *  SE for o primeiro bit (power=1), SE for algum dos seguintes  multiplicado
 *  por power=power*2e s depois  somado ao  resultado.  
 *  Em cada ciclo   efectuado o quociente da diviso anterior (number=number/10).
 *  O ciclo s termina quando o resto e quociente forem iguais a 0.
 *  No final devolve o resultado da converso.
 */
	public static int binaryToDecimal(int number){
		int power=1;
	    int resultDec=0;
	    while (((number/DEC)!=0)||((number%DEC)!=0)){
	    	if (power==1){
	    		resultDec+=(number%DEC);
				} 
			 else{
				 resultDec+=(number%DEC)*power;
	         }
	    	power=power*BIN;
	        number=(number/DEC);
	    }      
	    return resultDec;
	}
			
	/** Mtodo que recebe um nmero (number) na base decimal para converter para a 
	 *  base binria.
	 *  power  um contador que representa a potncia de 10, ou seja, o n de vezes 
	 *  que 10 tem de multiplicar por 10.
	 *  ENQUANTO o quociente OU o resto da diviso inteira forem diferentes de 0,  
	 *  calculado o resto da diviso inteira. Esse resto  somado ao resultado 
	 *  SE for o primeiro bit (power=1), SE for algum dos seguintes  multiplicado
	 *  por power=power*10 e s depois  somado ao  resultado.
	 *  Em cada ciclo   efectuado o quociente da diviso anterior (number=number/2).
	 *  O ciclo s termina quando o resto e quociente forem iguais a 0.
	 *  No final devolve o resultado da converso.
	 */
	public static int decimalToBinary(int number){
		int power=1;
	    int resultBin=0;
	    while (((number/BIN)!=0)||((number%BIN)!=0)){
	    	 if (power==1){
	    		 resultBin+=(number%BIN);
				 } 
				 else{
	                resultBin+=(number%BIN)*power;
	             }
	         power=power*DEC;
	         number=(number/BIN);
	        }      
	    return resultBin;
	}
	
	/** Mtodo que recebe um nmero decimal e conta o nmero de digitos.
	 *  numberOfDigits  um contador para o n de digitos. 
	 *  ENQUANTO o quociente OU o resto da diviso inteira forem diferentes de 0,  
	 *  efectuada o quociente da diviso inteira number=number/10. Assim  efectuado 
	 *  o quociente para o prximo ciclo. Neste passo  tambm incrementtado o contador 
	 *  numberOfDigits.
	 *  O ciclo s termina quando o resto e quociente forem iguais a 0.
	 *  No final devolve o resultado da contagem.
	 */
	public static int digits(int number){
		int numberOfDigits=0;
		while (((number/DEC)!=0)||((number%DEC)!=0)){
			number=number/DEC;
			numberOfDigits++;
	    }      
	    return numberOfDigits;
	}
	
	
}